> ## Documentation Index
> Fetch the complete documentation index at: https://docs.cognigy.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Create an MCP server

> Registers a remote MCP server so you can discover and import its tools. This endpoint doesn't accept credentials. An `oAuth2` or `customHeader` server references a Cognigy connection by `referenceId`.



## OpenAPI

````yaml https://api-trial.cognigy.ai/swagger/openapi.json post /mcp-servers
openapi: 3.0.3
info:
  contact:
    email: support@example.com
    name: API Support
  description: API for managing agents and related resources
  license:
    name: Apache 2.0
    url: http://www.apache.org/licenses/LICENSE-2.0.html
  termsOfService: http://swagger.io/terms/
  title: Agents API
  version: '1.0'
servers:
  - url: https://api-trial.cognigy.ai/v1
security:
  - ApiKey: []
tags:
  - name: Agents
  - name: Brand personas
  - name: Tools
  - name: Built-in tools
  - name: Skills
  - name: Built-in skills
  - name: MCP servers
  - name: Tool references
paths:
  /mcp-servers:
    post:
      tags:
        - MCP servers
      summary: Create an MCP server
      description: >-
        Registers a remote MCP server so you can discover and import its tools.
        This endpoint doesn't accept credentials. An `oAuth2` or `customHeader`
        server references a Cognigy connection by `referenceId`.
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/internal_mcpservers.CreateMCPServerRequest'
        description: MCP server data
        required: true
        x-originalParamName: server
      responses:
        '201':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/internal_mcpservers.MCPServerResponse'
          description: Created
        '400':
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/github_com_cognigy_ai-agents-v2_internal_middleware.ProblemDetailBadRequest
          description: >-
            Invalid request body, validation error, or unresolvable auth
            connection
        '403':
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/github_com_cognigy_ai-agents-v2_internal_middleware.ProblemDetailForbidden
          description: Access denied
        '409':
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/github_com_cognigy_ai-agents-v2_internal_middleware.ProblemDetailConflict
          description: A server with this referenceId already exists in the project
        '500':
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/github_com_cognigy_ai-agents-v2_internal_middleware.ProblemDetailInternalError
          description: Internal server error
components:
  schemas:
    internal_mcpservers.CreateMCPServerRequest:
      properties:
        authConnectionReferenceId:
          example: 550e8400-e29b-41d4-a716-446655440000
          type: string
        authType:
          enum:
            - none
            - oAuth2
            - customHeader
          example: none
          type: string
        headers:
          additionalProperties:
            type: string
          type: object
        name:
          example: GitHub MCP
          type: string
        projectId:
          example: 507f1f77bcf86cd799439011
          type: string
        timeoutSeconds:
          example: 12
          type: integer
        url:
          example: https://mcp.example.com/mcp
          type: string
      required:
        - name
        - projectId
        - url
      type: object
    internal_mcpservers.MCPServerResponse:
      properties:
        authConnectionReferenceId:
          type: string
        authType:
          example: none
          type: string
        createdAt:
          type: integer
        createdBy:
          example: 507f1f77bcf86cd799439011
          type: string
        headers:
          additionalProperties:
            type: string
          type: object
        id:
          example: 507f1f77bcf86cd799439011
          type: string
        lastChangedAt:
          type: integer
        lastChangedBy:
          example: 507f1f77bcf86cd799439011
          type: string
        name:
          type: string
        organisationId:
          example: 507f1f77bcf86cd799439011
          type: string
        projectId:
          example: 507f1f77bcf86cd799439011
          type: string
        referenceId:
          example: 550e8400-e29b-41d4-a716-446655440000
          type: string
        timeoutSeconds:
          example: 12
          type: integer
        url:
          type: string
      type: object
    github_com_cognigy_ai-agents-v2_internal_middleware.ProblemDetailBadRequest:
      properties:
        detail:
          example: request body validation failed
          type: string
        errors:
          items:
            $ref: >-
              #/components/schemas/github_com_cognigy_ai-agents-v2_internal_middleware.FieldError
          type: array
        instance:
          example: /v1/{resource}
          type: string
        status:
          example: 400
          type: integer
        title:
          example: Bad Request
          type: string
        traceId:
          example: api--a4d2f126-bec4-4544-a049-7c0cf08524ed
          type: string
        type:
          example: about:blank
          type: string
      type: object
    github_com_cognigy_ai-agents-v2_internal_middleware.ProblemDetailForbidden:
      properties:
        detail:
          example: 'access denied: insufficient permissions'
          type: string
        instance:
          example: /v1/{resource}/{id}
          type: string
        status:
          example: 403
          type: integer
        title:
          example: Forbidden
          type: string
        traceId:
          example: api--a4d2f126-bec4-4544-a049-7c0cf08524ed
          type: string
        type:
          example: about:blank
          type: string
      type: object
    github_com_cognigy_ai-agents-v2_internal_middleware.ProblemDetailConflict:
      properties:
        detail:
          example: a resource with this identifier already exists
          type: string
        instance:
          example: /v1/{resource}
          type: string
        status:
          example: 409
          type: integer
        title:
          example: Conflict
          type: string
        traceId:
          example: api--a4d2f126-bec4-4544-a049-7c0cf08524ed
          type: string
        type:
          example: about:blank
          type: string
      type: object
    github_com_cognigy_ai-agents-v2_internal_middleware.ProblemDetailInternalError:
      properties:
        detail:
          example: internal server error
          type: string
        instance:
          example: /v1/{resource}
          type: string
        status:
          example: 500
          type: integer
        title:
          example: Internal Server Error
          type: string
        traceId:
          example: api--a4d2f126-bec4-4544-a049-7c0cf08524ed
          type: string
        type:
          example: about:blank
          type: string
      type: object
    github_com_cognigy_ai-agents-v2_internal_middleware.FieldError:
      properties:
        field:
          type: string
        message:
          type: string
      type: object
  securitySchemes:
    ApiKey:
      description: '[Production] API key for production authentication'
      in: header
      name: X-API-Key
      type: apiKey

````